#include "PureNetwork.h"
#include "CDataBuffer.h"

namespace pun
{
	namespace core
	{
		// Constructor
		CDataBuffer::CDataBuffer(c32 nSize)
		{
			m_nSize = 0;
			m_nUseSize = 0;
			m_pData = new u8[nSize];
		}

		// Destructor
		CDataBuffer::~CDataBuffer()
		{
			SAFE_DELETEARR(m_pData);
		}

		// Copy data
		RESULT CDataBuffer::copyData(const void *ptr, c32 nPos, c32 nSize)
		{
			// Check parameter
			if(ASSERT_LOG((void *)ptr, "Variable ptr is null." ))
				return E_FAIL;
			if(ASSERT_LOG(nPos < 0 || nSize < 0, "Variable pos Or size is out of range."))
				return E_FAIL;
			if(ASSERT_LOG(nPos + nSize > m_nSize, "Out of Buffer Memory." ))
				return E_FAIL;

			// Copy data
			memcpy(&m_pData[nPos], ptr, nSize);

			// Update used size.
			m_nUseSize = nPos + nSize;
			return S_OK;
		}
	};
};