#ifndef _PURENETWORK_CDATA_BUFFER_H
#define _PURENETWORK_CDATA_BUFFER_H

#include "PureNetwork.h"
#include "IDataBuffer.h"
#include "punResultCode.h"

// DataBuffer Class

namespace pun
{
	namespace core
	{

		class CDataBuffer : public IDataBuffer
		{
		public:

			// Constructor
			CDataBuffer(c32 nSize);

			// Destructor
			virtual ~CDataBuffer();

			// Copy data
			RESULT copyData(const void *ptr, c32 nPos, c32 nSize);

			// Get Pointer
			u8 *getPointer()
			{
				return m_pData;
			}

			// Get used size
			c32 getUsedSize()
			{
				return m_nUseSize;
			}

		private:

			// Data Pointer
			u8 *m_pData;

			// Buffer Size
			c32 m_nSize;

			// Size to use
			c32 m_nUseSize;
		};
	};
};

#endif