#ifndef _PURNETWORK_CNULL_CONNECTION_H
#define _PURNETWORK_CNULL_CONNECTION_H

#include "PureNetwork.h"
#include "IConnection.h"

// PurNetwork Null Connection Class

namespace pun
{
	namespace socket
	{
		class CNullConnection : public IConnection
		{
		public:

			// Constructor
			CNullConnection();

			// Destructor
			virtual ~CNullConnection();

			// was it initialize ?
			virtual bool isInitialize()
			{
				return (m_socket != INVALID_SOCKET);
			}

			// Get socket step
			virtual E_CONNECTION_SOCKET_TYPE getSocketStep()
			{
				return m_socketStep;
			}

			// Get socket type
			virtual E_CONNECTION_TYPE getConnectionType()
			{
				return m_conType;
			}

			// Get address
			virtual c8 *getAddress()
			{
				return m_strAddress;
			}

			// Get port
			virtual c32 getPort()
			{
				return m_nPort;
			}

			// Get joined party
			IParty *getParty()
			{
				return m_pParty;
			}

		protected:

			// SOCKET
			SOCKET m_socket;

			// Socket state type
			E_CONNECTION_SOCKET_TYPE m_socketStep;

			// Connection type
			E_CONNECTION_TYPE m_conType;

			// Address
			core::stringc m_strAddress;

			// Port
			c32 m_nPort;

			// Joined Party
			IParty *m_pParty;
		};
	};
};	

#endif