#include "PureNetwork.h"
#include "CNullThread.h"

namespace pun
{
	namespace socket
	{
		// Constructor
		CNullThread::CNullThread(E_THREAD_TYPE threadType)
			: m_threadType(threadType)
		{
			m_threadState = ETS_READY;
		}

		// Destructor
		CNullThread::~CNullThread()
		{

		}

		// Accept function
		RESULT CNullThread::acceptThread(ISocket *pSocket)
		{
			IConnection *pNewConnection;
			IConnection *pConnection = pSocket->getConnection();
			EventMsg eventMsg(this, pSocket);

			// Construct new client message.
			eventMsg.nMsgType = EEMT_SOCKET;
			eventMsg.nMsgCode = ECMT_NEW_CLIENT;

			while(m_threadState == ETT_WORK)
			{
				// Accept.
				if((pNewConnection = pConnection->waitConnect()))
				{
					// Send event message.
					eventMsg.nValue[0] = (c32)pNewConnection;
					pSocket->onEvent(eventMsg);
				}
			}

			return S_OK;
		}

		// Worker function
		RESULT CNullThread::workerThread(ISocket *pSocket)
		{
			return S_OK;
		}
	};
};