#ifndef _PURNETWORK_CWIN32SOCKET2_CONNECTION_H
#define _PURNETWORK_CWIN32SOCKET2_CONNECTION_H

#include "PureNetwork.h"
#include "CNullConnection.h"

// Connection object for Win32

#ifdef _INCLUDE_WINSOCK2

namespace pun
{
	namespace socket
	{
		class CWinsock2Connection : public CNullConnection
		{
		public:

			// Constructor
			CWinsock2Connection();

			// Destructor
			virtual ~CWinsock2Connection();

			// Create socket
			RESULT createSocket(E_PROTOCOL_TYPE protocolType, E_ADDRESS_TYPE addressType, bool bOverlapped);

			// Set for using server
			RESULT setUseServer(SckListen sckListen);

			// Set for using client
			RESULT setUseClient(SckConnect sckConnect);

			// Load from socket informations
			virtual RESULT loadFromInformation(SOCKET socket, void *ptr);

			// Wait for new Connect
			virtual IConnection *waitConnect();

			// Wait for new Connect with extended Connection object.
			virtual IConnection *waitConnect(IConnection *pConnection);

			// Send Message.
			virtual RESULT sendMessage(core::CDataBuffer **ppDataBuffer, c32 nArraySize = 1);

		protected:

			// Constructor
			CWinsock2Connection(SOCKET newSocket, SOCKADDR_IN &sockAddr);

			// Socket information
			SOCKADDR_IN m_sockAddr;
		};
	};
};

#endif

#endif