#ifndef _PURENETWORK_ICONNECTION_H
#define _PURENETWORK_ICONNECTION_H

#include "PureNetwork.h"
#include "IParty.h"
#include "CDataBuffer.h"

// Connection interface
//
// This class is the same as socket.

namespace pun
{
	namespace socket
	{
		class IConnection : public IEventReceiver
		{
		public:

			// Constructor
			IConnection()
			{

			}

			// Destructor
			virtual ~IConnection()
			{

			}

			// was it initialize ?
			virtual bool isInitialize() = 0;

			// Create socket
			virtual RESULT createSocket(E_PROTOCOL_TYPE protocolType, E_ADDRESS_TYPE addressType, bool bOverlapped) = 0;

			// Set for using server
			virtual RESULT setUseServer(SckListen sckListen) = 0;

			// Set for using client
			virtual RESULT setUseClient(SckConnect sckConnect) = 0;

			// Wait for new Connect
			virtual IConnection *waitConnect() = 0;

			// Wait for new Connect with extended Connection object.
			virtual IConnection *waitConnect(IConnection *pConnection) = 0;

			// Get socket step
			virtual E_CONNECTION_SOCKET_TYPE getSocketStep() = 0; 

			// Get socket type
			virtual E_CONNECTION_TYPE getConnectionType() = 0;

			// Get address
			virtual c8 *getAddress() = 0;

			// Get port
			virtual c32 getPort() = 0;

			// Get joined party
			virtual IParty *getParty() = 0;

			// Load from socket informations
			virtual RESULT loadFromInformation(SOCKET socket, void *ptr) = 0;

			// Send Message.
			virtual RESULT sendMessage(core::CDataBuffer **ppDataBuffer, c32 nArraySize = 1) = 0;
		};
	};
};

#endif