#ifndef _PURENETWORK_IEVENT_RECEIVER_H
#define _PURENETWORK_IEVENT_RECEIVER_H

#include "IUnknown.h"

// Event Receiver Interface
//
// This class for sending events each other.

namespace pun
{
	// Define before.
	class IEventReceiver;

	// Event Structore
	struct EventMsg
	{
		// Sender
		IEventReceiver *pSender;

		// Receiver
		IEventReceiver *pReceiver;

		// Message Type
		c32 nMsgType;

		// Message Code
		c32 nMsgCode;

		// Message Value
		c32 nValue[2];

		// Constructor
		EventMsg(IEventReceiver *pSender = 0, IEventReceiver *pReceiver = 0)
		{
			this->pSender = pSender;
			this->pReceiver = pReceiver;
			nMsgType = 0;
			nMsgCode = 0;
			nValue[0] = nValue[1] = 0;
		}
	};

	// Event Class
	class IEventReceiver : public IUnknown	
	{
	public:
		
		// Constructor
		IEventReceiver()
		{

		}

		// Destructor
		virtual ~IEventReceiver()
		{

		}

		// EVENT :: onEvent
		virtual void onEvent(EventMsg eventMsg)
		{

		}
	};
};

#endif