#ifndef	_PURENETWORK_IUNKNOWN_H
#define _PURENETWORK_IUNKNOWN_H

#include "punDataTypes.h"

// COM+ Interface
// this class is for designing COM interface.

namespace pun
{
	class IUnknown
	{
	public:

		// Constructor
		IUnknown()
			: m_nReferCount(1)
		{

		}

		// Destructor
		virtual ~IUnknown()
		{

		}

		// Refer this class.
		void ref()
		{
			m_nReferCount++;
		}

		// Release this class.
		bool release()
		{
			m_nReferCount--;

			// Time to release really.
			if(!m_nReferCount)
			{
				delete this;
				return true;
			}

			// Wrong release
			if(m_nReferCount < 0)
			{
				m_nReferCount = 0;

				// Assertation
			}

			return false;
		}

		// Get reference count
		c32 getReferCount()
		{
			return m_nReferCount;
		}

	private:

		// Reference count
		c32 m_nReferCount;
	};
};

#endif