#include "PureNetwork.h"
#include "LogPrinter.h"

namespace pun
{
	namespace io
	{
		// Initialize logical variables.
		c32 LogPrinter::m_nPrintTarget = fileno(stdout);
		c8 *LogPrinter::m_pMemoryBuf = 0;

		// Put log
		void LogPrinter::put(E_LOG_LEVEL logLevel, const c8 *pMessage)
		{
			// Check initialized data.
			check();

			// construct log
			sprintf(m_pMemoryBuf, "PureNetwork [%s][?:?]%s\n", getLogLevel(logLevel), pMessage);

			// print it!
			write(m_nPrintTarget, m_pMemoryBuf, strlen(m_pMemoryBuf));

			// If fatal error, send to exit now!
			if(logLevel == ELL_FATAL_ERROR)
			{

			}
		}

		// Put log with information
		void LogPrinter::put(E_LOG_LEVEL logLevel, c8 *pFileName, c32 nLine, const c8 *pMessage)
		{

		}

		// Print log
		void LogPrinter::printf(E_LOG_LEVEL logLevel, c8 *pFormat...)
		{

		}

		// Print log with information
		void LogPrinter::printf(E_LOG_LEVEL logLevel, c8 *pFileName, c32 nLine, c8 *pFormat...)
		{

		}

		// Destroy me
		void LogPrinter::destroy()
		{
			SAFE_DELETEARR(m_pMemoryBuf);
		}

		// Check initialized data.
		void LogPrinter::check()
		{
			if(!m_pMemoryBuf)
				m_pMemoryBuf = new c8[255];
		}

		// get string from log level types
		c8 *LogPrinter::getLogLevel(E_LOG_LEVEL logLevel)
		{
			switch( logLevel )
			{
			case ELL_INFO:
				return "INFO";
			case ELL_WARNING:
				return "WARN";
			case ELL_ERROR:
				return "ERRO";
			default:
				return "FATA";
			}
		}
	};
};