#ifndef _PURENETWORK_PURE_NETWORK_H
#define _PURENETWORK_PURE_NETWORK_H

// Pure Network Header
//
// **This file must be load first to use this engine.

/////////////////////////////////////////////////////////////////////
// Define supported OS.
#ifdef WIN32		// Windows OS
#define _INCLUDE_WINSOCK2
#endif

#ifdef LINUX    // LINUX
#define _INCLUDE_LINSOCK
#endif
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Include Windows Socket files
#ifdef _INCLUDE_WINSOCK2
#include <winsock2.h>
#pragma comment(lib,"ws2_32.lib")
#endif
/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
// Include Linux Socket files
#ifdef _INCLUDE_LINSOCK
#include <sys/socket.h>
#include <sys/typedef.h>
#endif
/////////////////////////////////////////////////////////////////////

// Include logical files
#include "punDataTypes.h"
#include "punNetworkStructs.h"
#include "punList.h"
#include "punString.h"
#include "Defined.h"
#include "IUnknown.h"
#include "IEventReceiver.h"
#include "ISocket.h"
#include "IDataBuffer.h"
#include "IPureNetworkDevice.h"
#include "IThread.h"
#include "IParty.h"

// Define 'Export'
#ifdef _WIN32
#ifdef PURENETWORK_EXPORTS
#define PURENETWORK_API __declspec(dllexport)
#else
#define PURENETWORK_API __declspec(dllimport)
#endif
#endif

// Define Interfaces
namespace pun
{
	// Default using namespace.
	using namespace core;

	namespace socket
	{

	};

	namespace core
	{

	};

	namespace io
	{

	};

	// Define global function prototypes
	PURENETWORK_API IPureNetworkDevice* __stdcall createPureNetworkDeviceWin32(E_NETWORK_DRIVER_TYPE driverType);
};

#endif
